#include "Arguments.h"

#include <string>
#include <iostream>

using namespace std;

int main(int argc, char* argv[]) {
	
	// First, we need to initalize a new Arguments object
	Arguments a(argc, argv);
	
	// now you just provide the options you would like to have
	string this_binary = a.front();
	
	// !! remark that you can provide an option MORE THAN ONE time and you
	// !! will get subsequent options. A found option will be removed from the
	// !! argument list !!
	
	// Format: getXXX(option to search, default value, long option to search);
	//  the latter two are optional
	int my_int = a.getInt("-a");
	int my_int2 = a.getInt("-a", "340", "--with-long-option");
	int show_help = a.getFlag("-h", "--help");
	
	// if you are interested a supplied filename you can use front()
	//  or back() to pop the first or last element
	string filename = a.back();
	
	// now we check if we have popped all options of if there are some left (i.e. the user entered an option
	// that does not exist)
	if( a.size() > 0 ) {
		cout << "Unsupported option(s) given: " << a.list() << endl;
	}
	
	if( show_help || a.size() > 0 || filename == "") {
		cout << "usage: " << this_binary << " -a -h filename" << endl;
	}
	
	//now do your stuff
	
	cout << "a=" << my_int << " other a=" << my_int2 << endl;
	
	return 0;
}

